diff --git a/Tmain/readtags-ptags-escaping.d/exit-expected.txt b/Tmain/readtags-ptags-escaping.d/exit-expected.txt
new file mode 100644
index 0000000000..573541ac97
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/exit-expected.txt
@@ -0,0 +1 @@
+0
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-input-b_.tags b/Tmain/readtags-ptags-escaping.d/pseudo-input-b_.tags
new file mode 100644
index 0000000000..2df2a1e767
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-input-b_.tags
@@ -0,0 +1,2 @@
+!_PTAG	value\	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-input-bb.tags b/Tmain/readtags-ptags-escaping.d/pseudo-input-bb.tags
new file mode 100644
index 0000000000..09186cdde9
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-input-bb.tags
@@ -0,0 +1,2 @@
+!_PTAG	value\\	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-input-bt.tags b/Tmain/readtags-ptags-escaping.d/pseudo-input-bt.tags
new file mode 100644
index 0000000000..9ba0646931
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-input-bt.tags
@@ -0,0 +1,2 @@
+!_PTAG	value\t	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-name-b_.tags b/Tmain/readtags-ptags-escaping.d/pseudo-name-b_.tags
new file mode 100644
index 0000000000..8ef5ef2227
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-name-b_.tags
@@ -0,0 +1,2 @@
+!_PTAG\	value	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-name-bb.tags b/Tmain/readtags-ptags-escaping.d/pseudo-name-bb.tags
new file mode 100644
index 0000000000..97e83c8352
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-name-bb.tags
@@ -0,0 +1,2 @@
+!_PTAG\\	value	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/pseudo-name-bt.tags b/Tmain/readtags-ptags-escaping.d/pseudo-name-bt.tags
new file mode 100644
index 0000000000..0b78c96bec
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/pseudo-name-bt.tags
@@ -0,0 +1,2 @@
+!_PTAG\t	value	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-input-b_.tags b/Tmain/readtags-ptags-escaping.d/regular-input-b_.tags
new file mode 100644
index 0000000000..f02d988e91
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-input-b_.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag	/path/to/file\	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-input-bb.tags b/Tmain/readtags-ptags-escaping.d/regular-input-bb.tags
new file mode 100644
index 0000000000..f3061e45a5
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-input-bb.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag	/path/to/file\\	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-input-bt.tags b/Tmain/readtags-ptags-escaping.d/regular-input-bt.tags
new file mode 100644
index 0000000000..d07d2f2b01
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-input-bt.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag	/path/to/file\t	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-kind-b_.tags b/Tmain/readtags-ptags-escaping.d/regular-kind-b_.tags
new file mode 100644
index 0000000000..b96eaab6ef
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-kind-b_.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:\
diff --git a/Tmain/readtags-ptags-escaping.d/regular-kind-bb.tags b/Tmain/readtags-ptags-escaping.d/regular-kind-bb.tags
new file mode 100644
index 0000000000..0fce85f039
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-kind-bb.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag	/path/to/file	/^pattern$/;"	kind:\\
diff --git a/Tmain/readtags-ptags-escaping.d/regular-name-b_.tags b/Tmain/readtags-ptags-escaping.d/regular-name-b_.tags
new file mode 100644
index 0000000000..72d1a7d5c1
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-name-b_.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag\	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-name-bb.tags b/Tmain/readtags-ptags-escaping.d/regular-name-bb.tags
new file mode 100644
index 0000000000..254aabb0f7
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-name-bb.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag\\	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/regular-name-bt.tags b/Tmain/readtags-ptags-escaping.d/regular-name-bt.tags
new file mode 100644
index 0000000000..4cd8a53be9
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/regular-name-bt.tags
@@ -0,0 +1,2 @@
+!_PTAG	value	/comment/;"
+regular_tag\t	/path/to/file	/^pattern$/;"	kind:
diff --git a/Tmain/readtags-ptags-escaping.d/run.sh b/Tmain/readtags-ptags-escaping.d/run.sh
new file mode 100644
index 0000000000..819fadee82
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/run.sh
@@ -0,0 +1,51 @@
+#!/bin/sh
+
+# Copyright: 2022 Masatake YAMATO
+# License: GPL-2
+
+READTAGS=$3
+#V="valgrind --leak-check=full --track-origins=yes -v"
+V=
+
+. ../utils.sh
+
+if ! [ -x "${READTAGS}" ]; then
+	skip "no readtags"
+fi
+
+# {regular|pseudo}-{field}-{char0{char1}*}.tags
+for t in INIT									\
+			 regular-name-b_.tags				\
+			 regular-name-bb.tags				\
+			 regular-name-bt.tags				\
+			 regular-input-b_.tags				\
+			 regular-input-bb.tags				\
+			 regular-input-bt.tags				\
+			 regular-kind-b_.tags				\
+			 regular-kind-bb.tags				\
+			 pseudo-name-b_.tags				\
+			 pseudo-name-bb.tags				\
+			 pseudo-name-bt.tags				\
+			 pseudo-input-b_.tags				\
+			 pseudo-input-bb.tags				\
+			 pseudo-input-bt.tags				\
+		 ; do
+	case $t in
+		INIT)
+			;;
+		regular-*)
+			echo "# $t"
+			${V} ${READTAGS} -Ee -t $t -l || exit 1
+			echo
+			;;
+		pseudo-*)
+			echo "# $t"
+			${V} ${READTAGS} -Ee -t $t -D || exit 1
+			echo
+			;;
+		*)
+			echo "INTERNAL BUG"
+			exit 1
+			;;
+	esac
+done
diff --git a/Tmain/readtags-ptags-escaping.d/stderr-expected.txt b/Tmain/readtags-ptags-escaping.d/stderr-expected.txt
new file mode 100644
index 0000000000..e69de29bb2
diff --git a/Tmain/readtags-ptags-escaping.d/stdout-expected.txt b/Tmain/readtags-ptags-escaping.d/stdout-expected.txt
new file mode 100644
index 0000000000..d69b163b58
--- /dev/null
+++ b/Tmain/readtags-ptags-escaping.d/stdout-expected.txt
@@ -0,0 +1,42 @@
+# regular-name-b_.tags
+regular_tag\\	/path/to/file	/^pattern$/
+
+# regular-name-bb.tags
+regular_tag\\	/path/to/file	/^pattern$/
+
+# regular-name-bt.tags
+regular_tag\t	/path/to/file	/^pattern$/
+
+# regular-input-b_.tags
+regular_tag	/path/to/file\\	/^pattern$/
+
+# regular-input-bb.tags
+regular_tag	/path/to/file\\\\	/^pattern$/
+
+# regular-input-bt.tags
+regular_tag	/path/to/file\\t	/^pattern$/
+
+# regular-kind-b_.tags
+regular_tag	/path/to/file	/^pattern$/;"	kind:\\
+
+# regular-kind-bb.tags
+regular_tag	/path/to/file	/^pattern$/;"	kind:\\
+
+# pseudo-name-b_.tags
+!_PTAG\\	value	/comment/
+
+# pseudo-name-bb.tags
+!_PTAG\\	value	/comment/
+
+# pseudo-name-bt.tags
+!_PTAG\t	value	/comment/
+
+# pseudo-input-b_.tags
+!_PTAG	value\\	/comment/
+
+# pseudo-input-bb.tags
+!_PTAG	value\\\\	/comment/
+
+# pseudo-input-bt.tags
+!_PTAG	value\\t	/comment/
+
diff --git a/extra-cmds/printtags.c b/extra-cmds/printtags.c
index 8d8b3529e4..fa49b079e3 100644
--- a/extra-cmds/printtags.c
+++ b/extra-cmds/printtags.c
@@ -123,7 +123,8 @@ static void tagsPrintTag (const tagEntry *entry,
 		|| entry->address.pattern == NULL)
 		return;
 	if (pseudoTag)
-		print_str (entry->name, outfp);
+		printValue (entry->name, printingWithEscaping,
+					print_str, print_char, outfp);
 	else if (*entry->name == '!' && printingWithEscaping)
 	{
 		print_str ("\\x21", outfp);
